package com.hai.service;



import com.hai.entity.CmsPatch;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: CmsPatchService
 * @Description: 内容管理->附件管理
 * @author: gongjia
 * @date: 2019/10/31 15:15
 * @Copyright: 2019 www.shinwoten.com Inc. All rights reserved.
 */
public interface CmsPatchService {

    /**
     *
     * @Title: addPatch
     * @Description: 增加附件
     * @author: gongjia
     * @param: [cmsPatch]
     * @return: int
     * @throws
     */
    int addPatch(CmsPatch cmsPatch) throws Exception;

    /**
     *
     * @Title: addListPatch
     * @Description: 批量增加附件
     * @author: gongjia
     * @param: [patchList]
     * @return: int
     * @throws
     */
    int addListPatch(List<CmsPatch> patchList, Long contentId) throws Exception;

    /**
     *
     * @Title: delPatch
     * @Description: 删除附件
     * @author: gongjia
     * @param: [id]
     * @return: int
     * @throws
     */
    int delPatch(Long id) throws Exception;

    /**
     *
     * @Title: getListPatch
     * @Description:  查询附件列表
     * @author: gongjia
     * @param: [paramsMap]
     * @return: java.util.List<com.ncsmesc.entity.CmsPatch>
     * @throws
     */
    List<CmsPatch> getListPatch(Map<String, String> paramsMap) throws Exception;

    /**
     *
     * @Title: delPatchesByContentId
     * @Description: 根据内容id 批量删除附件
     * @author: gongjia
     * @param: [paramsMap]
     * @return: int
     * @throws
     */
    int delPatchesByContentId(Map<String, String> paramsMap) throws Exception;


}
