package com.hai.service;

import com.hai.entity.HighAgent;
import com.hai.model.HighAgentModel;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: HighAgentMsgService
 * @Description: 代理商信息
 * @author: 袁野
 * @date: 2021/3/25 11:36
 * @Copyright: 2021 https://hsgcs.dctpay.com/ Inc. All rights reserved.
 */
public interface HighAgentService {
    /**
     *
     * @Title: getListAgentMsg
     * @Description:  查询代理商信息列表
     * @Date: 2021/03/09 10:23
     * @author: Sum1Dream
     * @param: [map] map参数
     * @return: java.util.List<com.hai.entity.HighAgentMsg>
     * @throws Exception 抛出异常
     */

    List<HighAgent> getListAgentMsg(Map<String , String> map) throws Exception;

    /**
     *
     * @Title: findByUserId
     * @Description:  查询代理商信息详情
     * @Date: 2021/03/09 10:23
     * @author: Sum1Dream
     * @param: agentId 代理商信息id
     * @return: HighUser
     */
    HighAgent findByAgentMsgId(Long agentId);


    /**
     *
     * @Title: findByAgentName
     * @Description:  查询代理商名称查询详情
     * @Date: 2021/03/09 10:23
     * @author: Sum1Dream
     * @param: agentName 代理商名称
     * @return: HighUser
     */
    Boolean findByAgentName(String agentName);

    /**
     *
     * @Title: updateUser
     * @Description: 修改代理商信息信息
     * @author: Sum1Dream
     * @Date: 2021/03/09 11:23
     * @param: [highUser] 用户信息
     * @return: com.hai.entity.HighAgentMsg
     */
    void updateAgentMsg(HighAgentModel highAgentModel);

    /**
     *
     * @Title: insertUser
     * @Description: 新增代理商信息
     * @author: Sum1Dream
     * @Date: 2021/03/09 11:23
     * @param: [highUser] 用户信息
     * @return: com.hai.entity.HighAgentMsg
     */
    void insertAgentMsg(HighAgentModel highAgentModel)  throws Exception ;

}
